#include <bits/stdc++.h>

using namespace std;

#pragma GCC target("avx2")
#pragma GCC optimize("O3")

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    srand(time(NULL));    

    int n, m;
    cin >> n >> m;

    vector<vector<int>> a(n);
    vector<vector<int>> cands(m + 1);
    vector<uint> hashval(m + 1);
    vector<uint> hash(n);

    for (int i = 0; i < m; ++i) {
        hashval[i] = (rand()<<16)^rand(); 
    }

    auto test = [&](int i, int j) {
        int ptr1 = 0, ptr2 = 0;
        bool ok1 = false, ok2 = false, ok3 = false;

        while ((ptr1 < a[i].size()-1 || ptr2 < a[j].size()-1) && !(ok1 && ok2 && ok3)) {
            if (a[i][ptr1] == a[j][ptr2]) {
                ++ptr1;
                ++ptr2;
                ok1 = true;
                continue;
            }
            if (a[i][ptr1] < a[j][ptr2]) {
                ++ptr1;
                ok2 = true;
            } else {
                ++ptr2;
                ok3 = true;
            }
        }

        if (ok1 && ok2 && ok3) {
            cout << "YES\n";
            cout << i + 1 << ' ' << j + 1 << '\n';
            exit(0);
        }
    };

    vector<set<uint>> hashes(m + 1);

    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;

        if (k == 0) continue;

        a[i].resize(k);
        for (auto &x : a[i]) {
            cin >> x;
            --x;
            hash[i] ^= hashval[x];
        }
        sort(a[i].begin(), a[i].end());
        a[i].emplace_back(1e9);

        bool ok = (hashes[k-1].count(hash[i]) == 0);
    
        if (ok) {
            cands[k-1].emplace_back(i);
            hashes[k-1].insert(hash[i]);
        }
    }

    vector<int> c;

    for (int bit = 0; bit < m; ++bit) {
        for (auto &x : cands[bit]) c.emplace_back(x);
    }

    while (clock() < 2.95 * CLOCKS_PER_SEC) {
        int i = rand() % c.size();
        int j = rand() % c.size();
        if (i == j) continue;
        test(c[i], c[j]);
    }
    
    cout << "NO\n";
    return 0;
}